// Program:  Improve_T.cpp
#include "abs_relh.hpp" // for rel_divh1()
#include "bnd_arh.hpp"  // for abs_1mx_delh()
#include "bnd_util.hpp" // for Max_bnd_Xi()
#include <iostream>     // for cout
using namespace cxsc;
using namespace std;
real T_x(const interval& Xi, const real& delx)
{
    interval N,T;
    real delr,deln,eps;
    abs_1mx_delh(Xi,delx,N,deln);    // absl. error: 1-x
    abs_divh1(2*Xi,0,N,deln,T,delr); // absl. error: 2x/(1-x)
    rel_1px_delh(T,delr,N,eps);      // rel.  error: 1+2x/(1-x)
    return eps;   // Returning an upper bound eps of the relative   
}                 // error for T(x) = 1 + 2x/(1-x) = (1+x)/(1-x)

int main()
{
    interval X1(1e-6,0.2);
    real bnd, diam = 1e-5, delx=0;
    Max_bnd_Xi(T_x,X1,delx,diam,bnd);
    cout << RndUp << "Relative Fehlerschranke = " << bnd << endl;
}
