// Programm:  Poly1_relh.cpp Zur Abschtzung des relativen 
//            Auswertefehlers bei hochgenauer Arithmetik
#include "bnd_util.hpp"   // Wegen Horn_relh1(),Poly_Dat_rel(), ...
#include <iostream>       // Wegen cout

using namespace cxsc;
using namespace std;

int main()
{ // Polynomauswertung mit Hornerschema;  Gesucht: Rel. Auswertefehler
  // P(x) = 1 + a[1]*u^1 + ... + a[N]*u^N,  u(x)=x^k;
    int N,k;     // N: Polynomgrad;  k: u(x)=x^k, mit  1<= k <=6;
    interval X;  // Intervall der exakten Polynom-Argumente x
    real bnd, diam, epsx;
    Polynomgrad(N,k);      // Interaktive Eingabe von  N und k
    intvector Za(N),Ne(N); // Lb(Za)=Lb(Ne)=1, Ub(Za)=Ub(Ne)=N=Polynomgrad;
    Koeff_Rat(Za,Ne);      // Koeffizienten-Eingabe initialisiert Za,Ne;
    while(1) // Endlosschleife
    {
        Poly_Dat_rel(X,epsx,diam);  // Eingabe von X,epsx,diam;
            // epsx: relative Fehlerschranke der gestrten Argumente
            // diam: Mantissendurchmesser der Teilintervalle (10^(-5))
        bnd = Horn_relh1(Za,Ne,X,epsx,k,diam);  // bnd: relative Fehler-
        // schranke bei nur hochgenauer Arithmetik beim Hornerschema
        cout << RndUp 
             << "Relative Fehlerschranke bei hochgenauer Arithmetik = "
	     << bnd << endl << endl; 
    }
}


















