// Programm:  Poly_relh.cpp Zur Abschtzung des relativen Polynom-
//            Auswertefehlers bei hochgenauer Arithmetik. 
#include "bnd_util.hpp"   // Wegen Horn_relh(), Poly_Dat_rel(), ...
#include <iostream>       // Wegen cout

using namespace cxsc;
using namespace std;

int main()
{
// Polynomauswertung mit Hornerschema;  Gesucht: Rel. Auswertefehler;
// P(u) = a[0] + a[1]*u^1 + ... + a[N]*u^N,  u(x)=(x-x0)^k;
// a[j]: Exakte Koeffizienten, die durch Rundung von Dezimalwerten zur
//       jeweils nchsten Rasterzahl des IEEE-double-Formats entstehen
// Der Anwender muss die Werte von  N,k,x0  hier eingeben: 
    int N=3, k=1;  // N : Polynomgrad; k: u(x)=(x-x0)^k, mit  1<=k<=6;
    real x0 = 3;   // x0: Entwicklungspunkt muss Maschinenzahl sein!!
    // Der Anwender muss die dezimalen Nherungen der Koeffizienten 
    // hier eingeben: z.B. str0 = "108.1";  oder str0 = "1.01e-3";
    string str0 = "108";
    string str1 = "54";
    string str2 = "12";
    string str3 = "1";

    interval X;  // Intervall der exakten Polynom-Argumente x
    real bnd, diam, epsx;
    rvector a(0,N);  // a[j]: Exakte Koeffizienten aus S(2,53);
    
    str0 >> RndNext >> a[0];
    str1 >> RndNext >> a[1];
    str2 >> RndNext >> a[2];
    str3 >> RndNext >> a[3];
 
    // Die a[j] sind die zur nchsten Rasterzahl gerundeten strj

    while(1) // Endlosschleife
    {
        Poly_Dat_rel(X,epsx,diam);  // Eingabe von X,epsx,diam;
	    // X   : Einschlieung der exakten Polynom-Argumente
            // epsx: relative Fehlerschranke der gestrten Argumente
            // diam: Mantissendurchmesser der Teilintervalle (10^(-5))
        bnd = Horn_relh(a,x0,X,epsx,k,diam);  // bnd: relative Fehler-
        // schranke bei nur hochgenauer Arithmetik beim Hornerschema
        cout << RndUp 
             << "Relative Fehlerschranke bei hochgenauer Arithmetik = "
	     << bnd << endl << endl; 
    }
}


















