// Programm: Rat_relh.cpp Zur Abschtzung des Auswertefehlers einer
//           rationalen Funktion bei hochgenauer Arithmetik. 
#include "bnd_util.hpp"   // Wegen Rat_relh(), Poly_Dat_rel(), ...
#include <iostream>       // Wegen cout

using namespace cxsc;
using namespace std;

int main()
{
// Gesucht: Relativer Auswertefehler einer rationalen Funktion 
//          R(u) = P_N(u)/Q_M(u),  u = (x-x0)^k,  1<=k<=6;;
// P_N(u) = a[0] + a[1]*u^1 + ... + a[N]*u^N,  u = (x-x0)^k;
// Q_M(u) = b[0] + b[1]*u^1 + ... + b[M]*u^M,  u = (x-x0)^k;
// a[j],b[j]: Exakte Koeffizienten, die durch Rundung von 
//            Dezimalwerten zur jeweils nchsten Rasterzahl des
//            IEEE-double-Formats entstehen.
// Der Anwender muss die Werte von  N,M,k,x0  hier eingeben: 
    int N=4, M=4, k=2;  // N,M : Polynomgrad; 
                        // u(x)=(x-x0)^k, mit 1<=k<=6;
    real x0 = 0;   // x0: Entwicklungspunkt muss Maschinenzahl sein!
    // string strPi; // N+1 dezimale Komponenten von P_N(u)
    // Der Anwender muss die dezimalen Nherungen der Koeffizienten  
    // von P_N(u) hier eingeben:  z.B. strP[0] = "1.01e-3";
    string strP0 = "1.12837916709551256e+0";
    string strP1 = "1.35894887627277916e-1";
    string strP2 = "4.03259488531795274e-2";
    string strP3 = "1.20339380863079457e-3";
    string strP4 = "6.49254556481904354e-5";

    // string strQi; // M+1 dezimale Komponenten von Q_M(u)
    // Der Anwender muss die dezimalen Nherungen der Koeffizienten  
    // von Q_M(u) hier eingeben:  z.B. strQ[0] = "-1.22301";
    string strQ0 = "1.00000000000000000";
    string strQ1 = "4.53767041780002545e-1";
    string strQ2 = "8.69936222615385890e-2";
    string strQ3 = "8.49717371168693357e-3";
    string strQ4 = "3.64915280629351082e-4";

    interval X;  // Intervall der exakten Polynom-Argumente x
    real bnd, diam, epsx;
    rvector a(0,N),b(0,M); // a[j],b[j]: Exakte Koeffztn. aus S(2,53);

    strP0 >> RndNext >> a[0];
    strP1 >> RndNext >> a[1];
    strP2 >> RndNext >> a[2];
    strP3 >> RndNext >> a[3];
    strP4 >> RndNext >> a[4];

    strQ0 >> RndNext >> b[0];
    strQ1 >> RndNext >> b[1];
    strQ2 >> RndNext >> b[2];
    strQ3 >> RndNext >> b[3];
    strQ4 >> RndNext >> b[4];
    // Die a[j],b[j] sind die zur jeweils nchsten Rasterzahl 
    // gerundeten Strings strPj,strQj,  j = 0,1,...,4;

    while(1) // Endlosschleife
    {
        Poly_Dat_rel(X,epsx,diam);  // Eingabe von X,epsx,diam;
	    // X   : Einschlieung der exakten Polynom-Argumente
            // epsx: relative Fehlerschranke der gestrten Argumente
            // diam: Mantissendurchmesser der Teilintervalle (10^(-5))
        bnd = Rat_relh(a,b,x0,X,epsx,k,diam); // bnd: relative Fehler-
        // schranke bei nur hochgenauer Arithmetik beim Hornerschema
        cout << "Relative Fehlerschranke bei hochgenauer Arithmetik ="
	     << RndUp << bnd << endl << endl;
    }
}


















