// Programm:  book_expl15.cpp
#include "bnd_util.hpp" // Wegen eps2fractions()
#include <iostream>     // Wegen cout

using namespace cxsc;
using namespace std;

real T_x(const real& x)
{  // point function for T(x)
    return (1+x)/(1-x);
}
interval T_x(const interval& x)
{   // Intervallfunktion des monoton wachsenden Terms T(x)
    string str = "5.551116E-16"; // Rel. Fehlerschranke von T(x)
    real Z1p,N1p,Z1m,N1m;
    eps2fractions(str,Z1p,N1p,Z1m,N1m);
    real x1 = T_x(Inf(x)), x2 = T_x(Sup(x));
    x1 *= (sign(x1)<0) ? Z1p/N1p : Z1m/N1m;
    x2 *= (sign(x2)<0) ? Z1m/N1m : Z1p/N1p;
    return interval(x1,x2); // Einschlieung von T(x)
}

int main()
{
    interval y,x;
    cout << "Intervall aus [-10,+0.5] = ? "; cin >> x;
    y = T_x(x);
    cout << SetPrecision(15,15) 
	 << "Einschlg. von T(x) =  " << y << endl;
}
