// Programm:  book_expl27.cpp
#include "abs_relh.hpp" // Wegen rel_mulh2()
#include "bnd_util.hpp" // Wegen Max_bnd_Xi()
#include <imath.hpp>    // Wegen Z = ln(Xi);
#include <iostream>     // Wegen cout

using namespace cxsc;
using namespace std;

real T_x(const interval& Xi, const real& delx)
{
    interval LN_Xi,R,T;
    real del,eps,epsLN;   // epsLN: Fehlerschranke von ln()
    abs_mulh1(Xi,delx,Xi,delx,R,del);      // absl. Fehler bzgl. x*x
    LN_Xi = ln(Xi);
    string("[2.9398e-16,2.9398e-16]") >> T;
    epsLN = Sup(T);       // epsLN:  relativer Fehler der ln-Funktion
    rel_mulh2(R,del,LN_Xi,epsLN,T,eps);  // rel. Fehler:  (x*x)*ln(x)
    return eps;  // Rckgabe einer Schranke eps des relativen Fehlers.
}

int main()
{
    interval X1 = interval(1e-20,pred(1.0));
    real bnd, diam = 1e-5, delx=0;
    Max_bnd_Xi(T_x,X1,delx,diam,bnd);
    cout << RndUp << endl
         << "   **   Relat. Fehlerschranke = " << bnd << endl << endl;
}
