// Program lnx2y2_A2.cpp for calculating the relative error by 
// evaluating the term ln(x^2+y^2); x^2+y^2 is exactly 
// calculated in the accumulator, which can be read out
// with the relative error bound epsS=2^(-53);

#include "abs_relh.hpp" // For abs_addh1, ...
#include "bnd_util.hpp" // For Max_bnd_Xi()
#include <iostream>     // For cout
using namespace cxsc;
using namespace std;

real T_x(const interval& Xi, const real& delx)
{
    interval A;
    real eps;
    rel_ln_rel(Xi,delx,A,eps);
    return eps;
}
int main()
{
    interval X; string("[1.8189894E-12,0.25000001]") >> X;
    real bnd, diam = 1e-5, 
    delx = comp(0.5,-52); // delx = 2^(-53);
    Max_bnd_Xi(T_x,X,delx,diam,bnd);
    cout << RndUp << "Relative error bound = " << bnd << endl;
}
