// Program lnx2y2_A3.cpp for calculating the relative error by 
// evaluating the term:  0.5*[ln(r) + ln(1+(r1/r)];  x^2+y^2 = r+r1; 
// x^2+y^2 calculated in the accumulator dot = x^2+y^2;
// r = rnd(dot);  dot = dot-r;  r1 = rnd(dot);

#include "abs_relh.hpp" // For abs_addh1, ...
#include "bnd_util.hpp" // For Max_bnd_Xi()
#include <iostream>     // For cout

using namespace cxsc;
using namespace std;

const real epsS   = comp(0.5,-52);  // epsS   = 2^(-53);
const real one_eS = subd(1,epsS);   // one_eS = 1-epsS;
const real onepeS = addu(1,epsS);   // onepeS = 1+epsS;

real T_x(const interval& Xi, const real& delx)
{
    interval R,R1,A,B,Q;
    real absA,absB,absQ,eps,x,y,abs_r1,IXi=Inf(Xi),SXi=Sup(Xi);
    x = muld(IXi,one_eS);
    y = mulu(SXi,onepeS);
    R = interval(x,y);   // R: inclusion of the r values
    x = muld(-IXi,epsS);
    y = mulu(SXi,epsS);
    R1 = interval(x,y);  // R1: inclusion of the r1 values

    abs_ln_abs(R,0,A,absA);

    abs_r1=SXi;  times2pown(abs_r1,-106);  
    // abs_r1: absolute error of the r1
    abs_divh1(R1,abs_r1,R,0,Q,absQ);
    abs_lnp1_abs(Q,absQ,B,absB);

    rel_addh1(A,absA,B,absB,R,eps);
    return eps;
}

int main()
{
    interval X;  string("0.24999999,0.82812501") >> X;
    real bnd, diam = 1e-5, delx=0;
    Max_bnd_Xi(T_x,X,delx,diam,bnd);
    cout << RndUp << "Relative error bound = " << bnd << endl;
}
