// Program lnx2y2_abs.cpp for calculating the absolute error by 
// evaluating the term f4a(b) := (0.5*b)*b;
// for 0 <= b <= b0;

#include "abs_relh.hpp" // For abs_addh1, ...
#include "bnd_util.hpp" // For Max_bnd_Xi()
#include <iostream>     // For cout

using namespace cxsc;
using namespace std;

const real b0 = 6369051672525773.0 / 
                30191699398572330817932436647906151127335369763331523427009650401964993299137190816689013801421270140331747000246110759198164677039398341060491474011461568349195162615808.0;

real T_x(const interval& Xi, const real& delx)
{
    interval A=interval(0.5),B; // Including the factor 1/2
    real absa,absb;
    abs_mulh1(A,0,Xi,delx,B,absb);    // absb: abs. error for 0.5*Xi
    abs_mulh1(B,absb,Xi,delx,A,absa); // absa: abs. error for the
    return absa;                      // evaluation of (0.5*Xi)*Xi  
}

int main()
{
    interval X = interval(0,b0);
    real bnd, diam = 1e-5, delx=0;
    Max_bnd_Xi(T_x,X,delx,diam,bnd);
    cout << RndUp << "Absolute error bound = " << bnd << endl;
}
