// Program lnx2y2_ser.cpp for calculating the relative error by 
// evaluating the term ln(1+[x^2+y^2-1]); 

#include "abs_relh.hpp" // For abs_addh1, ...
#include "bnd_util.hpp" // For Max_bnd_Xi()
#include <iostream>     // For cout

using namespace cxsc;
using namespace std;

real T_x(const interval& Xi, const real& delx)
{
    interval A;
    real eps;
    rel_lnp1_rel(Xi,delx,A,eps);
    return eps;
}

int main()
{
    interval X = interval(-0.17187502,comp(-0.5,-157));
    real bnd, diam = 1e-5, epsr=comp(0.5,-52);
    // epsr: Upper bound of the relative error by reading the accu.
    Max_bnd_Xi(T_x,X,epsr,diam,bnd);
    cout << RndUp << "Relative error bound = " << bnd << endl;
}
