// Program  lnx2y2_y0.cpp  for calculating the machine number yo, so
// that the following statements are valid for the machine values y: 
// 1. y <  yo ==>  g(y):= (0.5*y)*y < MinReal with rounding downwards
// 2. y >= y0 ==>  g(y):= (0.5*y)*y >= MinReal with arbitrary ronding
//                                   modus by the two multiplications
#include <imath.hpp>    // For z = sqrt( interval(2) )
#include "bnd_util.hpp" // For IEEE2frac_int(b0,Z,N);
#include <iostream>     // For cout
using namespace cxsc;
using namespace std;

interval z = sqrt( interval(2) )*comp(0.5,-510);
real b0 = Sup(z),f4a,Z,N;

int main()
{
    do {
        b0 = pred(b0);    
        f4a = muld(0.5,b0);   // rouding downwards
        f4a = muld(f4a,b0);   // rouding downwards
    } while(f4a >= MinReal);

    b0 = succ(b0);  // This b0 is the searched y0
    IEEE2frac_int(b0,Z,N);
    cout << Fixed << SetPrecision(1,1) << "y0 = " 
         << Z << " / " << N << endl;
        f4a = muld(0.5,b0);
        f4a = muld(f4a,b0);
        if (f4a >= MinReal) cout << "f4a >= MinReal" << endl;
        else cout << "f4a < MinReal" << endl;
}
