// Programm:  sqrtp1m11.cpp zur Abschtzung des relativen 
//            Auswertefehlers bei hochgenauer Arithmetik. 

#include "bnd_util.hpp"   // Wegen Term_relh(), Term_Dat(), ...
#include <iostream>       // Wegen cout

using namespace cxsc;
using namespace std;

real Term(const interval& Xi)
// Berechnet den relativen Auswertefehler des Terms 
// T(x) = sqrt(x+1)-1 fr alle Maschinenzahlen x aus dem 
// Teilintervall Xi. 
{
    interval z,z1;            
    real d,d1;
    abs_1px_delh(Xi,0,z,d);  // d: absoluter Fehler bei der Berechnung
     // von x+1, mit Maschinenzahlen x aus dem Intervall Xi; z = 1+Xi;
    abs_sqrt_abs(z,d,z1,d1); // z1: sqrt(1+x);  d1: absl. Fehler
    rel_xm1_delh(z1,d1,z,d);   
    return d;  // Rckgabe des relativen Auswertefehlers
} // Term

int main()
{
// Berechnung einer relativen Fehlerschranke bez. der Auswertung
// eines Terms bei hochgenauer Arithmetik.

    interval X;  // Intervall der Maschinen-Argumente des Terms
    real bnd,diam;

    while(1) // Endlosschleife
    {
        X = interval(succ(-1),-0.5234375);
        cout << "diam = ? "; cin >> diam; 
        bnd = Term_relh(Term,X,diam); // bnd: relative Fehlerschranke
        // bei nur hochgenauer Arithmetik bei der Termauswertung.
        cout << RndUp 
             << "Relat. Fehlerschranke bei hochgenauer Arithmetik = "
             << bnd << endl << endl; 
    }
}
