// Programm:  sqrtp1m12.cpp zur Abschtzung des relativen 
//            Auswertefehlers bei hochgenauer Arithmetik. 

#include "bnd_util.hpp"   // Wegen Term_relh()
#include <iostream>       // Wegen cout

using namespace cxsc;
using namespace std;

real Term(const interval& Xi)
// Berechnet den relativen Auswertefehler des Terms 
// T(x) = x/(sqrt(x+1)+1) fr alle Maschinenzahlen x aus dem 
// Teilintervall Xi. 
{
    interval z,z1;            
    real d,d1;
    abs_1px_delh(Xi,0,z,d);  // d: absoluter Fehler bei der Berechnung
     // von x+1, mit Maschinenzahlen x aus dem Intervall Xi; z = 1+Xi;
    abs_sqrt_abs(z,d,z1,d1);  // z1: sqrt(1+Xi);  d1: absl. Fehler
    abs_1px_delh(z1,d1,z,d);  // z : sqrt(1+Xi)+1; d: absl. Fehler
    rel_divh1(Xi,0,z,d,z1,d1);   
    return d1;  // Rckgabe des relativen Auswertefehlers
} // Term

int main()
{
    interval X;  // Intervall der Maschinen-Argumente des Terms
    real bnd,diam,s;
    s = 9007199254740984.0/1125899906842624.0; 
    // s = 7.99999999999999289457264239899814128875732421875;
    // diam: Mantissendurchmesser der Teilintervalle (10^(-5))
    while(1) // Endlosschleife
    {
        X = interval(comp(0.5,-49),s);
        cout << "diam = ? "; cin >> diam; 
        bnd = Term_relh(Term,X,diam); // bnd: relative Fehlerschranke
        // bei nur hochgenauer Arithmetik bei der Termauswertung.
        cout << RndUp 
             << "Relat. Fehlerschranke bei hochgenauer Arithmetik = "
             << bnd << endl << endl; 
    }
}
